# Tag 3

## Docker Compose

Docker Compose ist ein Tool, mit dem man Multi-Container-Docker-Anwendungen
mit einer einzigen YAML-Datei (docker-compose.yml) definieren und verwalten kann. 
Damit kannst du mehrere Container gleichzeitig starten, konfigurieren und vernetzen – alles mit einem einzigen Befehl (docker-compose up). 

## Frontend v2 mit Docker Compose

![img](./docker-cmp.png)
Um eine gruppe von container mit docker compose zu starten müssen nur ein befehl verwendet werden


| Nutzen | Command |
|---|---|
| Image neu builden | docker compose build |
| Alle container starten (log wird ins terminal geprinted) | docker compose up |
| Alle container starten | docker compose up -d |

Docker compose datei: [docker-compose.yaml](./to-do-appv2/docker-compose.yaml)

## Portainer

![img](portainer.png)
![img](portainer-ui.png)


## Eigene App mit Portainer

Um mit Portainer die eigene App zu starten muss nach dem aufsetzen von Porteiner zuerst das Environment gewählt werden:

![port1](./portainer-1.png)

Da wir nur den Lokalen haben muss auch dieser ausgewählt werden.

Nach der auswahl kann im Seitenmenu der punkt Stacks ausgewählt werden. Danach muss ein neuer Stack erstellt werden:

![port2](./portainer-2.png)

Beim erstellen des Stacks wird zuerst ein belibiger name festgelegt, danach muss die docker-compose datei eingefügt werden.

![port3](./portainer-3.png)

Damit alle dateien für portainer zur verfügung stehen müssen sie in portainer-data/compose/id/ plaziert werden,
Danach kann am ende der Webseite auf Bestätigen geklickt werden und der Container wird erstellt:

![port4](./portainer-4.png)

## RabbitMQ

### Was ist RabbitMQ? 
RabbitMQ ist ein weit verbreiteter Message Broker, der das Advanced Message Queuing Protocol (AMQP) unterstützt. 
Er ermöglicht die asynchrone Kommunikation zwischen verschiedenen Anwendungen oder Microservices, 
indem er Nachrichten empfängt, speichert und an die richtigen Empfänger weiterleitet.

### Was macht ein Message Broker?
Ein Message Broker ist eine Middleware, die Nachrichten zwischen verschiedenen Systemen vermittelt. Seine Hauptaufgaben sind:

- Empfangen von Nachrichten von einem Sender (Producer).
- Zwischenspeichern der Nachrichten in einer Warteschlange.
- Verteilen der Nachrichten an einen oder mehrere Empfänger (Consumers).

Dadurch wird eine lose Kopplung zwischen Sender und Empfänger ermöglicht, was die Flexibilität und Skalierbarkeit eines Systems verbessert.

### Warum braucht es einen Message Broker bei Microservices?

Microservices sind oft unabhängig voneinander und kommunizieren über APIs oder Events. Ein Message Broker hilft dabei, folgende Probleme zu lösen:

- Entkopplung: Services sind nicht direkt voneinander abhängig, was die Wartbarkeit erleichtert.
- Asynchrone Verarbeitung: Services können Nachrichten senden, ohne auf eine direkte Antwort zu warten, was die Performance verbessert.
- Fehlertoleranz: Falls ein Service ausfällt, bleiben Nachrichten in der Warteschlange, bis er wieder verfügbar ist.
- Lastverteilung: Mehrere Instanzen eines Consumers können Nachrichten parallel verarbeiten.

### Warum ist ein Message Broker bei der Skalierung von Microservices wichtig?
Ein Message Broker erleichtert die horizontale Skalierung, indem er:

- Last verteilt: Mehrere Consumer können parallel Nachrichten aus der Queue verarbeiten.
- Verkehrsspitzen abfängt: Eingehende Nachrichten werden zwischengespeichert, sodass sie nach und nach abgearbeitet werden können.
- Systemstabilität erhöht: Ein Service-Ausfall führt nicht zu Datenverlust, da die Nachrichten gespeichert bleiben.
- Geschwindigkeit verbessert: Microservices müssen nicht immer aufeunander warten.

## Jaeger UI

Links können die namen der einzelnen Services abgelesen werden. Her wird Play.Trading, Play.Inventory und Play.Identity verwendet.

![services](./service.png)

## Prometheus

Prometheus mit gestopptem Container:

![Prometheus](./prom-1.png)

Prometheus mit hinzugefügten docker metrics:

![Prometheus](./prom-2.png)

## Grafana

Grafana nach den aufgaben auf smartlearn:

![Grafana](./gaf.png)
