# Tag 6
docker, hochladen, pull & push, docker run, images, docker compose, kubernetis
## Raft-Konsens-Algorithmus

## Anzahl Server 

Kubernetes (oft K8s abgekürzt) ist eine Open-Source-Plattform zur Automatisierung der Bereitstellung, Skalierung und Verwaltung von containerisierten Anwendungen. Es koordiniert Container in Clustern und stellt sicher, dass sie effizient laufen, sich automatisch erholen und skalierbar sind.

**Containerisierung:** Jeder Microservice läuft in einem eigenen Docker-Container.

**Verwaltung:** Kubernetes verwaltet diese Container auf mehreren Servern (Nodes).

**Skalierung:** Falls viele Kunden gleichzeitig einkaufen, skaliert Kubernetes automatisch neue Instanzen des Backends hoch.

**Restart:** Falls ein Container abstürzt, startet Kubernetes ihn neu.

## Was sind Microservices

Bei einer Anwendung wird eine komplette App in kleine, unabhängige Dienste aufgeteilt wird. Jeder Microservice erfüllt eine spezifische Funktion, kommuniziert über APIs und kann unabhängig entwickelt, bereitgestellt und skaliert werden.

Ein Online-Shop beispielsweise besteht aus mehreren Microservices:

**Bestellservice** – Verarbeitet Bestellungen

**Zahlungsservice** – Führt Zahlungen durch

**Produktservice** – Verwaltert Produktdaten

Jeder Service läuft unabhängig und kann separat skaliert oder aktualisiert werden.



## Vergleich: Lightweight Kubernetes-Anwendungen  

| Feature            | **Minikube**        | **MicroK8s**       | **Kubeadm**       | **Docker for Windows (Kubernetes Mode)** |
|--------------------|--------------------|--------------------|-------------------|-----------------------------------------|
| **Eignung**       | Lokale Entwicklung  | Dev/Test | Cluster Setup     | Dev/Test auf Windows/Mac |
| **Installation**  | VM die Kubernetis ausführt | Snap-Packet | Manuelle Einrichtung | Aktivierung über Docker Desktop |
| **Plattformen**   | Windows, macOS, Linux | Linux, Windows (WSL) | Linux | Windows |
| **Ressourcenverbrauch** | Mittel | Sehr wenig | Mittel bis hoch | Mittel |
| **Benutzerfreundlichkeit** | Einfach | Sehr einfach | Komplex | Sehr einfach |
| **Cluster-Fähigkeit** | Einzelner Node | Mehrere Nodes möglich | Multi-Node | Einzelner Node |
| **Einsatzbereich** | Entwicklung, Test | Edge-Computing (datenverarbeitung dort wo die daten produziert werden), kleine Cluster | Produktiv-Cluster | Entwicklung, Test |

### Fazit: 
- **Minikube**: Ideal für lokale Tests mit vollständigem Kubernetes-Erlebnis.  
- **MicroK8s**: Super leicht, gut für Edge-Computing.  
- **Kubeadm**: Für die manuelle Einrichtung von echten Kubernetes-Clustern.  
- **Docker for Windows (Kubernetes Mode)**: Einfach für Entwickler, aber auf einen Node beschränkt.

## Instalation von Kubernetes
Kobernetes kann in einigen kurzen schritten mit docker aktiviert werden
1. Docker desktop aufstarten
2. Oben rechts einstellungen wählen
3. Im Menu Kubernetes wählen und rechts bei Enable Kubernetes ein häcklein setzen
![img](./kub.png)
4. Unten rechts auf Apply & restart klicken

## Lens Installiert
![lens](./lens.png)