# Tag 5
docker, hochladen, pull & push, docker run, images, docker compose, kubernetis
## Raft-Konsens-Algorithmus

Der Raft-Konsens-Algorithmus ist ein Verfahren, das in verteilten Systemen dafür sorgt, dass mehrere Server eine einheitliche Entscheidung treffen – selbst wenn einige von ihnen ausfallen. Er wird oft für verteilte Datenbanken oder Systeme wie Kubernetes verwendet.

**Führerwahl (Leader Election)**: Einer der Server wird zum Leader gewählt, der die Entscheidungen trifft. Die anderen sind Follower und folgen ihm. Falls der Leader ausfällt, wird ein neuer gewählt.

**Log-Replikation**: Der Leader nimmt Anfragen entgegen und speichert sie in einem Log. Dann verteilt er die Änderungen an die Follower, die sie bestätigen müssen.

**Konsistenzsicherung**: Eine Änderung gilt erst als bestätigt, wenn die Mehrheit der Server sie gespeichert hat.

## Warum eine ungerade Anzahl an Servern?

Eine ungerade Anzahl verhindert Patt-Situationen bei Abstimmungen. Raft benötigt eine Mehrheit (z. B. mindestens 2 von 3 Servern), um eine Entscheidung zu treffen.

Bei 3 Servern reicht eine Mehrheit von 2, um fortzufahren.

Daher nutzt man immer eine ungerade Anzahl, um handlungsfähig zu bleiben.


## Notizen in Kubernetis
![kubernetis](./kubernetis.png)


## Self Healing
Self-Healing in Kubernetes bedeutet, dass das System in der Lage ist, Probleme automatisch zu erkennen und zu beheben, um den gewünschten Zustand der Anwendungen aufrechtzuerhalten. In der praxis bedeutet das einfach das der pod nach einem crash automatisch wieder gestartet wird.

## Scale Up
Scale Up in Kubernetes bedeutet, die Anzahl der Pods oder Ressourcen zu erhöhen, um eine höhere Last zu bewältigen oder die Leistung zu verbessern. Dies wird gemacht falls ein pod eine erhöhte auslastung hat.

## Scale Down

Scale Down beschreibt den Prozess, die Anzahl der Pods oder Ressourcen zu verringern, wenn die Last abnimmt oder weniger Kapazität benötigt wird. Dies hilft, Ressourcen effizient zu nutzen und Kosten zu sparen.

## Rolling Update
Hier kann man sehen wie nach und nach die pods ersezt werden, leider funktionierte die anzeige mit lens nich, weswegen hier jezt ein etwas weniger schöner screenshot aus der konsole ist
![rollingupdate](./rolling.png)

## Blue Green Deployment
Blue/Green Deployment ist eine Strategie, um Anwendungen sicher und ohne Ausfallzeiten zu aktualisieren. Dabei werden zwei separate Umgebungen (Blue und Green) bereitgestellt: Eine Umgebung (z. B. Blue) hostet die aktuelle Version der Anwendung, während die andere (Green) die neue Version bereitstellt. Sobald die neue Version getestet und freigegeben ist, wird der Traffic von der alten auf die neue Umgebung umgeleitet. Falls Probleme auftreten, kann der Traffic schnell zurück zur alten Version geschaltet werden, was das Risiko von Ausfällen minimiert. Diese Methode eignet sich ideal für kritische Anwendungen, die hohe Verfügbarkeit erfordern.