# Tag 7

## ClusterIP & NodeIP

**ClusterIP**: Eine ClusterIP ist eine interne, stabile IP-Adresse für Services innerhalb eines Kubernetes-Clusters. Sie ermöglicht die Kommunikation zwischen Pods, ist aber von außen nicht erreichbar

**NodeIP**: Eine NodeIP ist die öffentliche IP-Adresse eines Worker-Knotens, über die externe Zugriffe auf den Cluster möglich sind.


## LoadBalancer

Ein LoadBalancer verteilt externen Traffic auf mehrere Kubernetes-Services oder Pods. Er erstellt eine externe IP-Adresse und leitet Anfragen automatisch an verfügbare Instanzen weiter, um Lasten auszugleichen und Ausfälle zu vermeiden.


## Zugriff auf die Webseite
![kubernetis](./web.png)


## Zugriff auf 127.0.0.1
**Ingress beim zugriff auf 127.0.0.1 ein Error 404 erhalten**

Der Ingress ist für die Domain my-app.com konfiguriert. Wenn man 127.0.0.1 (localhost) aufruft, passt der Hostname nicht zur Regel my-app.com, sodass der Ingress keine passende Route findet. Folge: Ein 404-Error.

Der Ingress-Controller prüft bei jeder Anfrage den Host-Header, um festzustellen, welcher Service die Anfrage verarbeiten soll. Da 127.0.0.1 keinen Host-Header mit my-app.com sendet, kann der Ingress die Anfrage keinem Backend-Service zuordnen.

## Portainer auf Kubernetis

![portainer](./lens_portainer.png)