## Installation meines Projektes

### Voraussetzungen:
- `kubectl` wurde erfolgreich mit Kubernetes verbunden.
- Die benötigten Dateien (`mongo-deployment.yaml`, `flask-deployment.yaml`, und der `dump/`-Ordner) befinden sich im aktuellen Verzeichnis.

### Schritte zur Installation:

1. **Öffnen eines CMD-Fensters**  
    Öffnen Sie ein CMD-Fenster und navigieren Sie zu dem Ordner `Tag 9 KW 13`, in dem sich die Projektdateien befinden.  
    ```bash
    cd "Pfad/zum/Ordner/Tag 9 KW 13"
    ```
<!--  -->
2. **Erstellen einer ConfigMap**  
    Erstellen Sie eine ConfigMap, damit Kubernetes später weiß, wo sich die Dump-Dateien befinden, die erste Daten in die MongoDB einfügen:  
    ```bash
    kubectl create configmap mongo-init-config --from-file=dump/

3. **Anwenden der Deployments**  
    Navigieren Sie zu den Kubernetis dateien und wenden Sie die bereitgestellten Deployments an. Diese beinhalten alle notwendigen Konfigurationen, einschließlich der Services:  
    ```bash
    cd "./kubernetis/"
    kubectl apply -f mongo-deployment.yaml
    kubectl apply -f flask-deployment.yaml
    ```

4. **Überprüfen der Pods und Services**  
    Zeigen Sie die laufenden Pods und Services an und warten Sie, bis alle Services gestartet sind.  
    Hinweis: Es kann vorkommen, dass das Frontend beim ersten Start crasht, da die Datenbank möglicherweise noch keine Verbindung erlaubt. In diesem Fall wird das Frontend automatisch neu gestartet und sollte nach einigen Sekunden verfügbar sein.  
    ```bash
    kubectl get pods
    kubectl get services
    ```

5. **Herstellen einer Verbindung zum Frontend**  
    Sobald die Services laufen, können Sie über Ihren Browser auf das Frontend zugreifen:  
    [http://localhost:5000](http://localhost:5000)
